#include "alphabeta.h"


int AlphaBeta::alphaBeta(Move **bestMove, int alpha, int beta, int level){
  treeNodes++;
  *bestMove = NULL;

  if (game->getState()!=0){
    if (game->getState()==TIE)
      return 0;
    else
      return -INFTY;
  }
    
  if (!level)
    return -game->evaluate();
  
  vector<Move*> moves = game->getLegalMoves();
  Move *dummy;
  
  *bestMove = moves[0];    
  int val;
  
  vector<Move*>::iterator it = moves.begin();
  vector<Move*>::iterator eit = moves.end();
  
  for(; it != eit; it++){
    game->commitMove( *it );
    val = -alphaBeta(&dummy,-beta,-alpha,level-1);
    if(dummy != NULL)
      delete dummy;
    game->undoMove( *it );
    if (val > alpha){
      alpha = val;
      *bestMove = *it;
    } 
    if (alpha >= beta){
      alpha = beta;
      break;
    }
  } 
  for( it = moves.begin(); it != eit; it++)
    if (*it != *bestMove)
      delete *it;

  return alpha;
}


Move *AlphaBeta::findMove(){
  Move *bestMove;
  treeNodes = 0;
  int result = alphaBeta( &bestMove, -INFTY, INFTY, LEVEL_MAX);
  cout << "AlphaBeta ocena: " << result << " ilosc przejrzanych wezlow: " << treeNodes << endl;
  return bestMove;
}
  

Move *AlphaBeta::makeMove(const Move *opponent){
  if (opponent != NULL) game->commitMove(opponent);
  Move *move = findMove();
  game->commitMove(move);
  return move;
}


