#ifndef _GAME_H_
#define _GAME_H_

#include "move.h"

#include <vector>
#include <iostream>

using namespace std;

class Game{
 protected:
  int state; // stan gry,  0 - gra sie toczy
	     //		   1 - wygral gracz 1
	     //		   2 - wygral gracz 2
	     //		   TIE=3 - remis
  int ply; // numer ruchu
  
 public:
  Game() : ply(0), state(0){}
  // generuje mozliwe ruchy  
  virtual vector<Move *> getLegalMoves() const=0;

  // czyj ruch?
  virtual int getPlayerToMove() const{ return (ply%2)+1;}

  // wykonaj ruch i zmien stan gry
  virtual int commitMove(const Move *move)=0;
  // cofnij ruch
  virtual void undoMove(const Move *move)=0;

  // wykonaj pusty ruch 
  virtual void doNullMove(){ply++;}
  // cofnij pusty ruch
  virtual void undoNullMove(){ply--;}

  // zwroc stan gry
  virtual int getState() const{ return state;}
  virtual bool isFinished() const{return (state>0);}
  virtual int getWinner() const{ return state;}

  virtual int evaluate() const=0;  
  
  virtual void dump(ostream &o) const=0;
};

#endif
