#ifndef _GOMOKU_H_
#define _GOMOKU_H_

#include "defs.h"
#include "move.h"
#include "game.h"
#include <vector>

#define BOARD_SIZE 5
#define LINE_SIZE 4

class GoMoku : public Game{
public:

    class Move : public ::Move{
      int x,y;
    public:
      Move(int _x, int _y) : x(_x), y(_y){}
      int getX() const{ return x;}
      int getY() const{ return y;}
      void write(ostream &o) const;
      void read(istream &i);
    };

    static int dx[4];
    static int dy[4];

protected:
  char board[BOARD_SIZE][BOARD_SIZE]; // plansza gry
  int stones; // liczba pionow na planszy
  
public:

  GoMoku();

  vector< ::Move *> getLegalMoves() const;
  bool isLegal(int x, int y) const{
    return ((x >= 0) && (y >= 0) && (x < BOARD_SIZE) && (y < BOARD_SIZE));
  }
  
  int commitMove(const ::Move *move);  
  void undoMove(const ::Move *move);

  // ocen plansze 
  int evaluate() const;
  
  void dump(ostream& o) const;
};


#endif
