#include "negamax.h"


int NegaMax::negaMax(Move **bestMove, int level){
  treeNodes++;
  *bestMove = NULL;

  if ( game->getState() != 0){
    if ( game->getState() == TIE)
      return 0;
    else
      return -INFTY;
  }
    
  if (!level)
    return -game->evaluate();
  

  vector<Move*> moves = game->getLegalMoves();
  Move *dummy;
  
  *bestMove = moves[0];    
  int best = -INFTY, val;
  
  vector<Move*>::iterator it = moves.begin();
  vector<Move*>::iterator eit = moves.end();
  
  for (; it != eit; it++ ){
    game->commitMove( *it );
    val = -negaMax( &dummy, level-1); 
    if (dummy != NULL)
      delete dummy;
    game->undoMove( *it );
    if ( val > best ){
      best = val;
      *bestMove = *it;
    }
  }

  for( it = moves.begin(); it != eit; it++)
    if (*it != *bestMove)
      delete *it;

  return best;
}


Move *NegaMax::findMove(){
  Move *bestMove;
  treeNodes = 0;
  int result = negaMax( &bestMove, LEVEL_MAX);
  cout << "NegaMax ocena: " << result << " ilosc przejrzanych wezlow: " << treeNodes << endl;
  return bestMove;
}
  

Move *NegaMax::makeMove(const Move *opponent){
  if (opponent != NULL) game->commitMove(opponent);
  Move *move = findMove();
  game->commitMove(move);
  return move;
}


